//
//This sample program is provided AS IS and may be used, executed, copied and
//modified without royalty payment by customer (a) for its own instruction and 
//study, (b) in order to develop applications designed to run with an IBM 
//product, either for customer's own internal use or for redistribution 
//by customer, as part of such an application, in customer's own products. "
//
//5724-J34 (C) COPYRIGHT International Business Machines Corp. 2015
//All Rights Reserved * Licensed Materials - Property of IBM
//
var cacheclient = require('./cache.js');
var debug = require('debug')('bluemix-session');

module.exports = function(session) {
  var Store = session.Store;
  var inMemoryDefault = session.MemoryStore;
  
  function SessionCacheStore(options) {
	
	if (options) {
		cacheclient.update(options);	
	}
	
	if(options.fallbackMemoryStore)
	{
		var isCloudFoundry = cacheclient.isCfEnvironment();
		if (!isCloudFoundry) // when CF environment is not available but fallback is enabled, use express-session in memory
		{
			debug("using in-memory default");
			return new inMemoryDefault();
		}
	}
    var self = this;
    Store.call(self, options);
  }
  
  SessionCacheStore.prototype.__proto__ = Store.prototype;
  
  /**
   * grab the given session by ID if it exists
   */
  SessionCacheStore.prototype.get = function (sessionId, callback) {
	cacheclient.getCache(sessionId, callback);
  };

  
  /**
   * Attempts store/update a given session to the grid with given ID
   *
   */
  SessionCacheStore.prototype.set = function (sessionId, session, callback) {
	cacheclient.putCache(sessionId,session,callback);
	}
  
   /**
   * destroy a given session provided and ID, callback handles any errors from operation
   */
  SessionCacheStore.prototype.destroy = function (sessionId, callback) {
	cacheclient.removeCache(sessionId, callback);
  };
  
  return SessionCacheStore;
};